<template>
  <div class="g-list">
    <GLoaderView v-if="loading" />
    <div v-else-if="resultList && resultList.length > 0">
      <span v-if="nbSelectedObjects > 0">
        {{ nbSelectedObjects }} lignes sélectionnées <button class="btn-link" @click="clearSelection">Clear</button><br>
        (ctrl + click pour sélectionner plusieurs lignes)
      </span>

      <table v-if="resultList.length > 0" cellspacing="0">
        <thead v-if="columns">
          <tr class="my-list-row">
            <th>
              <input v-model="selectAll" type="checkbox" style="cursor: pointer;">
            </th>
            <th
              v-for="(column, index) in columns"
              :key="index">
              {{ column }}
            </th>
          </tr>
        </thead>

        <tbody>
          <component
            :is="rowComponent"
            v-for="(result, index) in resultList"
            :key="index"
            :object="result"
            @select="result.__selected=$event"
            @refresh="$emit('refresh')" />
        </tbody>
      </table>

      <div style="margin-top: 10px;">
        <span v-if="nbResults >= 2">{{ nbResults }} résultats</span>
        <span v-else>{{ nbResults }} résultat</span>
      </div>

      <div v-if="hasMore" class="g-list-bottom">
        <button
          :class="{ 'loading': loadingMore }"
          class="btn-secondary"
          @click="loadMore">
          Voir plus
        </button>
      </div>
    </div>
    
    <div v-else style="display: flex; justify-content: center;">
      {{ noResultMessage }}
    </div>
  </div>
</template>

<script>

import GLoaderView from "./GLoaderView.vue";


export default {
  name: "GList",
  components: {
    GLoaderView,
  },
  props: {
    rowComponent: {
      type: [String, Object],
      required: true,
    },
    columns: {
      type: Array,
      required: false,
      default: null,
    },
    loading: {
      type: Boolean,
      required: true,
    },
    loadingMore: {
      type: Boolean,
      required: true,
    },
    resultList: {
      type: Array,
      required: false,
      default: null,
    },
    nbResults: {
      type: Number,
      required: false,
      default: 0,
    },
    hasMore: {
      type: Boolean,
      required: false,
      default: false,
    },
    noResultMessage: {
      type: String,
      required: false,
      default: "Aucun résultat à afficher",
    },
  },
  emits: ["loadMore", "refresh"],
  data() {
    return {
      selectAll: false,
    };
  },
  computed: {
    nbSelectedObjects() {
      var count = 0;

      for (const result of this.resultList) {
        if (result.__selected) {
          count = count + 1;
        }
      }

      return count;
    },
  },
  watch: {
    selectAll(newVal) {
      this.onSelectAll(newVal);
    },
  },
  methods: {
    clearSelection() {
      if (this.selectAll) {
        this.selectAll = false;
      } else {
        this.onSelectAll(false);
      }
    },
    loadMore() {
      this.$emit("loadMore");
    },
    onSelectAll(selected) {
      for (const result of this.resultList) {
        result.__selected = selected;
      }
    },
  },
};

</script>


<style lang="scss" scoped>

  .g-list {
    flex-grow: 1;
    display: flex;
    flex-direction: column;
    background: white;
    padding: 10px;

    table {
      width: 100%;

      thead {
        tr {
          th {
            text-align: left;
          }
        }


      }
    }

    .g-list-bottom {
      display: flex;
      justify-content: center;
    }
  }

</style>
  